/*
   A complete C++ program that uses the function drawPolyLineFile()
   from Figure 2.24, page 62, of the textbook to draw Figure 3.11(b)
   from page 101.
*/
#include <windows.h>
#include <iostream>
#include <fstream>
#include "glut.h"

using namespace std;

//<<<<<<<<<<<<<<<<<<<<<< drawPolyLineFile >>>>>>>>>>>>>>>>>>>>>>
void drawPolyLineFile(char *fileName)
{
   fstream inStream;
   inStream.open(fileName, ios::in);  // open the file
   if(inStream.fail()) {cout << "can't open data file!"; return;};

   GLint numpolys;
   inStream >> numpolys;              // read the number of polylines
   for(int j = 0; j < numpolys; j++)  // read each polyline
   {
      GLint numLines;
      inStream >> numLines;           // read the number vertices in this polyline
      GLint x ,y;
      glBegin(GL_LINE_STRIP);        // draw the next polyline
        for (int i = 0; i < numLines; i++)
        {
           inStream >> x >> y;       // read the next x, y pair
           glVertex2i(x, y);
        }
      glEnd();
   }
   glFlush();  // forces the drawing to take place
   inStream.close();
}

//<<<<<<<<<<<<<<<<<<<<<<<<<<< setWindow >>>>>>>>>>>>>>>>>>>>>>>>>>>
void setWindow(GLdouble left, GLdouble right, GLdouble bottom, GLdouble top)
{
   glMatrixMode(GL_PROJECTION);        // define window
   glLoadIdentity();
   gluOrtho2D(left, right, bottom, top);
}

//<<<<<<<<<<<<<<<<<<<<<<<<<<< display >>>>>>>>>>>>>>>>>>>>>>>>>>>
void display(void)
{
   glClear(GL_COLOR_BUFFER_BIT);   // clear screen

   for (int i = 0; i < 10; i++)
      for(int j = 0; j < 10; j++)
      {
         if ( (i+j) % 2 == 0 )
            setWindow(0.0, 640.0, 0.0, 440.0); // right side up window
         else
            setWindow(0.0, 640.0, 440.0, 0.0); // upside down window
         glViewport(i*64, j*44, 64, 44);       // set the next viewport
         drawPolyLineFile("dino.dat");         // draw it again
      }
}

//<<<<<<<<<<<<<<<<<<<<<<<<<<< myInit >>>>>>>>>>>>>>>>>>>>>>>>>>>.
void myInit(void)
{
   glClearColor(1.0f,1.0f,1.0f,1.0f);  // background is white
   glColor3f(0.0f,0.0f,0.0f);          // set color of stuff
   glMatrixMode(GL_PROJECTION);        // define window
   glLoadIdentity();
   gluOrtho2D(0, 640.0, 0, 480.0);
}

//<<<<<<<<<<<<<<<<<<<<<< main >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
int main(int argc, char **argv)
{
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
   glutInitWindowSize(640,480); // open a 640 by 480 window
   glutInitWindowPosition(100, 100);
   glutCreateWindow("dino.dat");
   glutDisplayFunc(display);
   myInit();
   glutMainLoop();
   return 0;
}