/*
   This is a corrected and slightly reorganized version of Figure 3.3 from pages 93-94.
*/
#include <windows.h>
#include <math.h>
#include "glut.h"

void reshape(int, int);

void myDisplay(void) // plot the sinc function, using world coordinates
{
   GLfloat x;
   const float pi = 3.14159265358979;

   // specify the viewport
   //glViewport( 0,  0, 640, 480);  // left, bottom, width, height (in pixels)
   //glViewport(20, 20, 100, 100);  // left, bottom, width, height (in pixels)

   glClear( GL_COLOR_BUFFER_BIT );

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   // automatically uses the defined window and viewport,
   // clips properly, and performs the proper mapping
   glBegin(GL_LINE_STRIP);
      for(x = -4.0; x < 4.0; x += 0.1)  // draw the plot
      {
         glVertex2f(x, sin(pi * x) / (pi * x));
      }
   glEnd();
   glFlush();
}


int main(int argc, char** argv)
{
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB);
   // specify the screen window
   glutInitWindowSize(640,480);       // width, height (in pixels)
   glutInitWindowPosition(100,150);   // left, top (in pixels)
   glutCreateWindow("Sinc Function");
   glutDisplayFunc(myDisplay);
   //glutReshapeFunc(reshape);      // Uncomment this line and see what happens.

   glClearColor(1.0,1.0,1.0,0.0);
   glColor3f(0.0f,0.0f,1.0f);
   glLineWidth(1.0);

   // specify the world window
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-4.0, 4.0, -0.22, 1.0); // left, right, bottom, top (in world coordinates)

   // specify the viewport
   glViewport(0, 0, 640, 480);       // left, bottom, width, height (in pixels)

   glutMainLoop( );

   return 0;
}


/* The reshape() callback function */
void reshape(int width, int height)
{
   myDisplay();

   printf("We got a \"reshape(%d, %d)\" event\n", width, height);
}//reshape()