/*
   This program uses a single color buffer.

   Compare this program with doubleBufferDemo.c

*/
#include <windows.h>
#include "glut.h"


/* Prototype for the display callback function */
void display( void );


int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);
   glutInitWindowSize(500,500);
   glutInitWindowPosition(50,50);
   glutCreateWindow("Single Buffer Demo");
   glutDisplayFunc(display);

   /* Initialize OpenGL state */
   /* attributes */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */
   glColor3f(1.0, 0.0, 0.0);         /* draw in red */
   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-1.0, 1.0, -1.0, 1.0); /* viewing volume */
   glMatrixMode(GL_MODELVIEW);

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* The display() callback function */
void display( void )
{
   glClear(GL_COLOR_BUFFER_BIT);  /* clear the window */

   Sleep(1000);
   glFlush();

   glBegin(GL_LINES);
      glVertex2f(-0.5, -0.5);
      glVertex2f(-0.5,  0.5);
   glEnd();

   Sleep(1000);
   glFlush();

   glBegin(GL_LINES);
      glVertex2f(-0.5,  0.5);
      glVertex2f( 0.5,  0.5);
   glEnd();

   Sleep(1000);
   glFlush();



   glBegin(GL_LINES);
      glVertex2f( 0.5,  0.5);
      glVertex2f( 0.5, -0.5);
   glEnd();

   Sleep(1000);
   glFlush();

   glBegin(GL_LINES);
      glVertex2f( 0.5, -0.5);
      glVertex2f(-0.5, -0.5);
   glEnd();

   Sleep(1000);
   glFlush();

}//display()
